from cython.operator cimport dereference as deref
import numpy as np
cimport numpy as np
from libc.stdint cimport (
    int8_t, uint8_t,
    int16_t, uint16_t,
    int32_t, uint32_t,
    int64_t, uint64_t)

from cythrust.thrust.device_vector cimport device_vector


ctypedef int8_t Value
ctypedef device_vector[Value] Vector
ctypedef device_vector[Value].iterator Iterator


cdef class DeviceVector:
    cdef device_vector[int8_t] *_vector
    cdef object dtype
    cdef object ctype


cdef class DeviceVectorView:
    cdef device_vector[int8_t] *_vector
    cdef device_vector[int8_t].iterator _begin
    cdef device_vector[int8_t].iterator _end
    cdef object dtype
    cdef object ctype